BMapCom.Controller.create(function() {

    var $ = function(q) {
        return document.querySelector(q);
    };

    var pageParamCache = {},
        currentRank,
        currentPage = 0,
        loadding = false;
        gotoTop = true;

    var sourceDelegate = {
        search: function() {
            var self = this;

            BMapCom.SysApi.getRuntimeInfo([BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION, BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID], function(runtimeInfo) {
                var domain = "http://client.map.baidu.com/detail?",
                    type = ['resou_rank', 'haoping_rank', 'biaosheng_rank'];
                var param = [
                    'qt=ranklist',
                    'city_id=' + runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID],
                    'point_x=' + runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locX,
                    'point_y=' + runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locY,
                    'aoi_name=' + pageParamCache.option.aoi_name,
                    'indus=' + pageParamCache.option.indus,
                    'type=' + type[currentRank],
                    'pn=' + currentPage
                ].join('&');

                /*var param = [
                    'qt=ranklist',
                    'city_id=131',
                    'point_x=12960181.78',
                    'point_y=4831673.68',
                    'aoi_name=北京市|海淀区|五道口',
                    'type=' + type[currentRank],
                    'indus=cater',
                    'pn=' + (currentPage + 1)
                ].join('&');*/
                var url = domain + param;
                return BMapCom.Loader.jsonp(url)
                    .ok(function(result) {
                        if (result.data.errno === 0) {
                            self.onSourceLoadFinish(result.data);
                        } else {
                            BMapCom.Loader.jsonp(url)
                                .ok(function(result){
                                    if(result.data.errNo === 0){
                                        self.onSourceLoadFinish(result.data);
                                    }
                                });
                        }

                    })
                    .error(function() {
                        self.onSourceLoadFailed();
                    });
            });
        }
    };


    var bindPageEvent = function(detailPage, detailTpl) {
        var navEvt = new BMapCom.EventDelegater($("#navHeader"));

        var source = new BMapCom.DataSource();
        source
            .delegate(sourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result) {
                    if (currentPage) {
                        $("#toplist").innerHTML += detailTpl.list({
                            encodeURIComponent: encodeURIComponent,
                            list: result.data.content,
                            page: currentPage
                        });
                        $(".see-more").style.display = "none";
                    } else {
                        $("#toplist").innerHTML = detailTpl.list({
                            encodeURIComponent: encodeURIComponent,
                            list: result.data.content,
                            page: 0
                        });
                        $(".see-more").style.display = "block";
                    }
                    if(gotoTop){
                        document.body.scrollTop = 0;
                    }
                    loadding = false;
                },
                startSourceLoad: function(param) {
                    this.search();
                }
            });

        navEvt.on("nav:tap", function(e) {
            var index = parseInt(this.getAttribute("data-index"), 10);
            if (loadding || index === currentRank) {
                return ;
            }
            loadding = true;
            currentRank = index;
            [].forEach.call($("#navHeader").querySelectorAll("li"), function(li) {
                li.className = "";
            });
            this.className = "active";
            currentPage = 0;
            gotoTop = true;
            source.update();

            BMapCom.Stat.sendOnline({
                "da_src":"rankpg." + ['hotsearch', 'popularity', 'soaring'][index] + "tab",
                "da_act":"click",
                "da_model":"plugin_cater",
                "da_trd":"cater"
            });
        });

        var evt = new BMapCom.EventDelegater($('#toplist'));

        evt.on('extend:tap/stopPropagation', function(e) {
            if (this.className === "comment") {
                this.className = "comment extend";
            } else {
                this.className = "comment";
            }
        });

        evt.on('goDetail:tap', function(e) {
            if (BMapCom.config('monkeyTest')) {
                return false;
            }
            var entranceParam, pageName;
            BMapCom.Stat.sendOnline({
                "da_src":"rankpg." + ['hotsearch', 'popularity', 'soaring'][currentRank] + "poilist",
                "da_act":"click",
                "da_model":"plugin_cater",
                "da_trd":"cater"
            });
            
            switch (pageParamCache.option.indus) {
            case 'cater':
                pageName = 'caterPoiDetailPage';
                break;
            case 'hotel':
                pageName = 'hotelPoiDetailPage';
                break;
            case 'scenery':
                pageName = 'sceneryPoiDetailPage';
                break;
            default:
                pageName = 'mainMapPoiDetailPage';
                break;
            }
            entranceParam = {
                "page": pageName,
                "pageParam": {
                    //必传参数
                    "uid": this.getAttribute('data-uid'),
                    "poiName": this.getAttribute('data-name'),
                    "from": pageParamCache.from + "_rankPage",
                    "streetScape": "1",
                    "indoorScape": ""
                }
            };
            BMapCom.Kernel.notify('changePage', entranceParam);
        });

        var seeMoreEvt = new BMapCom.EventDelegater($(".see-more"));

        seeMoreEvt.on("seeMore:tap", function(e) {
            if (loadding) {
                return ;
            }
            loadding = true;
            currentPage++;
            gotoTop = false;
            source.update();
            BMapCom.Stat.sendOnline({
                "da_src":"rankpg.loadmorebt",
                "da_act":"click",
                "da_model":"plugin_cater",
                "da_trd":"cater"
            });
        });
    };

    var initMethod = function(detailPage, detailTpl) {
        var source = new BMapCom.DataSource();
        document.body.setAttribute('data-role','pageView');
        document.body.innerHTML = detailTpl.body();
        
        //detailPage.pageBody.innerHTML = detailTpl.body();
        //绑定数据对象代理
        source
            .delegate(sourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result) {
                    $("#toplist").innerHTML = detailTpl.list({
                        encodeURIComponent: encodeURIComponent,
                        list: result.data.content,
                        page: 0
                    });
                    bindPageEvent(detailPage, detailTpl);
                    $(".see-more").style.display = "block";
                    BMapCom.Kernel.notify('webPageReady');
                },
                startSourceLoad: function(param) {
                    this.search();
                }
            });

        //绑定页面事件代理
        detailPage
            .delegate({
                shouldWaiting: function() {
                    return true;
                },
                onCreate: function(pageParam, ready) {

                    /*BMapCom.Stat.sendOnline({
                        "da_src" : "poiDetailPG",
                        "da_trd" : "scope",
                        "da_model" : "plugin_scenery",
                        "da_act": "show"
                    });*/

                    pageParamCache = pageParam;

                    currentRank = (pageParamCache.option.rank && pageParamCache.option.rank > 0) ? pageParamCache.option.rank : 0;

                    $("#navHeader").querySelectorAll("li")[currentRank].className = 'active';

                    source.update();
                },
                onDestory: function() {
                    renderContainer.innerHTML = "";
                }
            });

    };
    return {
        initWithPage: initMethod
    };
});
