
BMapCom.Plugin.define(function(PluginBuilder){

    var ButtonView = PluginBuilder.create({
        hasTemplate:false,
        hasCSS:false
    });

    ButtonView.delegate({
        onCreate: function(opt, context) {
            var o = {
                'width':opt.width || '100%',
                'height':opt.height || '38px',
                'text':opt.text || '',
                'icon':opt.icon || '',
                'events':opt.events || {}
            };
            context.style.cssText = [
                'border-radius:4px',
                'border:1px solid #d9d9d9',
                'background-color:#fff',
                'height:' + o.height,
                'line-height:' + o.height,
                'overflow:hidden',
                'position:relative',
                'margin:10px',
                'text-align:center'
            ].join(';');
            context.setAttribute('data-role', 'buttonView');
 
            var text = document.createElement('div');
            text.style.cssText = [
                'display:inline-block',
                'height' + o.height + 'px',
                'line-height' + o.height + 'px',
                'padding-left:27px'
            ].join(';');

            text.className += ' ' + o.icon;
            text.innerHTML = o.text;
            context.appendChild(text);
            for(var evtType in o.events){
                BMapCom.event.on(this.container, evtType, o.events[evtType]);
            }
        }
    });
    return ButtonView;
});
