BMapCom.Template.create("ImageListViewTpl", {
body:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,title=$data.title,showTotal=$data.showTotal,total=$data.total,showSort=$data.showSort,$string=$helpers.$string,imageListHTML=$data.imageListHTML,isMore=$data.isMore,$out='';$out+='<div class="image-list-content">\n        <div class="il-head">\n            <span class="il-head-title">';
$out+=$escape(title);
$out+='</span>\n            ';
 if (showTotal) {
$out+='\n                <span class="il-head-total">(';
$out+=$escape(total);
$out+=')张</span>\n            ';
}
$out+='\n            ';
 if (showSort) {
$out+='\n                <div class="il-head-sort">\n                    <div class="il-head-sort-selected" data-ek="sortSelected" data-value="close">\n                        <div class="il-head-sort-selected-value">默认排序</div>\n                        <div class="il-head-sort-arrow"></div>\n                    </div>\n                    <div class="il-head-sort-option-container il-head-sort-option-hidden">\n                        <div data-ek="sortDefault" class="il-head-sort-option">默认排序</div>\n                        <div style="border-bottom:1px solid #d9d9d9;margin:0 10px;"></div>\n                        <div data-ek="sortTime" class="il-head-sort-option">时间排序</div>\n                    </div>\n                </div>\n            ';
}
$out+='\n        </div>\n        <div class="il-body clearfix" id="ilBody">\n            ';
$out+=$string(imageListHTML);
$out+='\n        </div>\n        ';
if(isMore){
$out+='\n            <div class="il-foot" data-ek="seeMore">\n                <span>查看更多</span>\n                <div class="il-right-arrow"></div>\n            </div>\n        ';
}
$out+='\n    </div>';
return new String($out);
},
imageItem:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,index=$data.index,imageUrl=$data.imageUrl,comment=$data.comment,$out='';$out+='<div class="ii-content" data-ek="imageItem" index="';
$out+=$escape(index);
$out+='">\n        <div class="ii-img-container">\n            <img class="ii-img" src="';
$out+=$escape(imageUrl);
$out+='"/>\n            ';
 if (comment) {
$out+='\n                <div class="ii-comment">\n                    <span class="ii-comment-content">';
$out+=$escape(comment);
$out+='</span>\n                </div>\n            ';
}
$out+='\n        </div>\n    </div>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {
    var util = BMapCom.util; 
    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

    plg.delegate({
        onInstantiate: function(imageData, context) {
            var self = this;

            var listHTML = [];
            var bodyWidth = document.body.clientWidth; 
            imageData.list.forEach(function(item) {
                item.imageUrl = util.getThumbUrl(item.imageUrl, bodyWidth, 1000);
                listHTML.push(self.template.imageItem(item));
            });
            imageData.isMore = imageData.total ? (imageData.total > imageData.list.length) : false;
            imageData.imageListHTML = listHTML.join('');;
            context.innerHTML = this.template.body(imageData);

            context.selectedNode = context.querySelector('.il-head-sort-selected-value');
            context.selectedValue = "default";
            context.optionNode = context.querySelector('.il-head-sort-option-container');
            context.optionNodeStatus = 'close';
            context.arrowNode = context.querySelector('.il-head-sort-arrow');

            var dispatcher = new BMapCom.EventDispatcher();

            var evt = new BMapCom.EventDelegater(context);
            if (context.optionNode) {
                //如果排序框存在
                evt.on('sortSelected:tap', function(e) {
                    if (context.optionNodeStatus == 'close') {
                        context.optionNodeStatus = 'open';
                        context.optionNode.style.display = 'block';
                        context.arrowNode.className = 'il-head-sort-arrow arrow-rotate';
                    } else {
                        context.optionNodeStatus = 'close';
                        context.optionNode.style.display = 'none';
                        context.arrowNode.className = 'il-head-sort-arrow';
                    }
                });
                evt.on('sortDefault:tap', function(e) {
                    if (context.selectedValue != 'default') {
                        dispatcher.fire('sort', ['default']);
                    }
                    context.selectedNode.innerHTML = '默认排序';
                    context.selectedValue = 'default';
                    context.optionNodeStatus = 'close';
                    context.optionNode.style.display = 'none';
                    context.arrowNode.className = 'il-head-sort-arrow';
                });
                evt.on('sortTime:tap', function(e) {
                    if (context.selectedValue != 'time') {
                        dispatcher.fire('sort', ['time']);
                    }
                    context.selectedNode.innerHTML = '时间排序';
                    context.selectedValue = 'time';
                    context.optionNodeStatus = 'close';
                    context.optionNode.style.display = 'none';
                    context.arrowNode.className = 'il-head-sort-arrow';
                });
            }
            evt.on('imageItem:tap', function(e) {
                var index = this.getAttribute('index')
                dispatcher.fire('imageItemClick', [index]);
            });
            evt.on('seeMore:tap', function(e) {
                dispatcher.fire('seeMoreClick', []);
            });

            return {
                'event': dispatcher,
                'refresh': function(imageData) {
                    var listHTML = [];
                    imageData.list.forEach(function(item) {
                        listHTML.push(self.template.imageItem(item));
                    });
                    var ilBody = context.querySelector('#ilBody');
                    ilBody.innerHTML = listHTML.join('');
                },
                'append': function(imageData) {
                    var listHTML = [];
                    imageData.list.forEach(function(item) {
                        listHTML.push(self.template.imageItem(item));
                    });
                    var ilBody = context.querySelector('#ilBody');
                    ilBody.innerHTML = ilBody.innerHTML + listHTML.join('');

                    if (!imageData.isMore) {
                        context.querySelector('.il-foot').style.display = 'none';
                    }
                }
            };
        }
    });

    return plg;
});