BMapCom.Template.create("ListCardViewTpl", {
});
BMapCom.Plugin.define(function(PluginBuilder) {

    var artTemplate = {};//require('./lib/artTemplate');
 
    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });
    plg.delegate({
        onInstantiate: function(initData, context) {

            var dispatcher = new BMapCom.EventDispatcher(),
                self = this,
                isShow = false,
                initNum = 3;

            if (!initData || !context) {
                return dispatcher;
            }

            if (!initData.desc && (!initData.data || !initData.data.length) || initData.single && !initData.title ) {
                return dispatcher;
            }

            //渲染页面
            renderPage(initData);

            BMapCom.Kernel.notify('webPageReady');


            function renderRender(obj){

                obj.data = obj.data || [];
                obj.icon = 0;

                var htmls = [];
                htmls.push('<div class="box0 com_list_box">',
                    '<div class="com_list_title"',
                      obj.icon ? ' style="background: url(\'' + obj.icon + '\') no-repeat left center;background-size: ' + (obj.iconSize||17) + 'px;padding-left:' + (obj.indent||22) + 'px"' : '',
                    '>',
                      obj.title,
                      obj.openNew ? '<span class="com_list_openNew" data-ek="com_list_openNew"></span>' : '',
                      obj.collapse ? '<span class="com_list_collapse_up" data-ek="com_list_collapse"></span>' : '',
                    '</div>',
                    (obj.data.length || obj.desc) ? '<div class="line_split"></div>' : '');

                if(obj.custom){
                    var render = artTemplate.compile(obj.custom);
                    var html = render(obj.customData);
                    htmls.push('<div class="com_list_body">', html, '</div>');
                }else{
                    if(obj.desc){
                        htmls.push('<div class="com_list_body_desc"', obj.row ? 'style="max-height:' + obj.row * 19 +'px;overflow:hidden;"' : '','>', obj.desc, '</div>');
                    }else{
                        obj.data.length && htmls.push('<div class="com_list_body">');
                        for (var i = 0; i < obj.data.length; i++) {
                            htmls.push('<div class="com_list_content', obj.goto ? ' com_list_goto' : '','" data-ek="com_list_item" data-index="',i,'"',i > initNum -1 ? ' style="display:none"' : '','>',obj.data[i],'</div>');
                            htmls.push((i < obj.data.length - 1) ? '<div class="com_list_splitLine"' + (i > initNum - 2 ? ' data-status="1" style="display:none"' : '') + '></div>' : '');
                        }
                        obj.data.length && htmls.push('</div>');
                    }
                }
                if(obj.data.length > 3 && obj.more !== 0 || obj.desc && obj.row){
                    htmls.push('<div class="line_split"></div>');
                    htmls.push('<div class="com_list_more" data-ek="', 
                        (obj.desc ? 'com_list_more_desc' : 'com_list_more'), 
                        '">', 
                        obj.more_custom ? obj.more_custom : 
                        '<span class="com_list_more_text">' + 
                        (obj.moreText||'查看全部') + 
                        '</span><span class="' + (obj.more_append ? '' : 'com_list_more_down') + '"></span></div>');
                }
                htmls.push('</div>');
                return htmls.join('');
            }

            function renderPage(vm){

                dispatcher.initData = vm;

                //处理模板需要的数据对象

                setTimeout(function(){
                    //渲染
                    context.innerHTML = renderRender(vm);//self.template.body(vm);

                    if(isShow) return;
                    isShow = true;
                    //绑定事件，仅绑定一次
                    var evt = new BMapCom.EventDelegater(context);
                    evt.on('com_list_openNew:tap', function(e){
                        dispatcher.fire('openNewClick', [this.getAttribute('data-value')]);
                    });
                    evt.on('com_list_collapse:tap', function(e){
                        var body = context.querySelector('.com_list_body');
                        var bar = context.querySelector('.com_list_more');
                        if(this.className == 'com_list_collapse_up'){
                            this.className = 'com_list_collapse_down';
                            body && (body.style.display = "none");
                            bar && (bar.style.display = "none");
                            body.previousSibling.style.display = 'none';
                        }else{
                            this.className = 'com_list_collapse_up';
                            body && (body.style.display = "block");
                            bar && (bar.style.display = "block");
                            body.previousSibling.style.display = 'block';
                        }
                    });
                    evt.on('com_list_item:tap', function(e) {
                        dispatcher.fire('itemClick', [this.getAttribute('data-index')]);
                    });
                    evt.on('com_list_more:tap', function(e){
                        if(vm.more_custom){
                            dispatcher.fire('moreClick', this);
                            return;
                        }
                        var text = this.querySelector('.com_list_more_text');
                        var icon = text.nextSibling;
                        if(!vm.custom){
                            var body = context.querySelector('.com_list_body');
                            var items = body.querySelectorAll('.com_list_content');
                            var splits = body.querySelectorAll('.com_list_splitLine');

                            Array.prototype.forEach.call(items, function(o, i){
                                if(icon.className == "com_list_more_down"){
                                    if(o.style.display == 'none'){
                                        o.style.display = 'block';
                                        o.className += ' com_list_show';
                                    }
                                }else{
                                    if(o.className.indexOf('com_list_show') != -1){
                                        o.style.display = 'none';
                                        o.className = o.className.replace(' com_list_show', '');
                                    }
                                }
                            });

                            Array.prototype.forEach.call(splits, function(o, i){
                                if(o.getAttribute("data-status") == 1){
                                    if(icon.className == "com_list_more_down"){
                                        o.style.display = 'block';
                                    }else{
                                        o.style.display = 'none';
                                    }
                                }
                            });
                            if(icon.className == "com_list_more_down"){
                                icon.className = 'com_list_more_up';
                                text.innerText = "收起全部";
                            }else{
                                icon.className = 'com_list_more_down';
                                text.innerText = "查看全部";
                            }
                        }else{
                            if(vm.more_append){

                            }else{
                                if(icon.className == "com_list_more_down"){
                                    icon.className = 'com_list_more_up';
                                }else{
                                    icon.className = 'com_list_more_down';
                                }
                            }
                            dispatcher.fire('moreClick', [this.getAttribute('data-value')]);
                        }
                    });
                    evt.on('com_list_more_desc:tap', function(e){
                        var text = this.querySelector('.com_list_more_text');
                        var icon = text.nextSibling;
                        var pre = this.previousSibling.previousSibling;
                        if(icon.className == "com_list_more_down"){
                            this.setAttribute("height_backup",pre.style.maxHeight);
                            pre.style.maxHeight = "";
                            icon.className = "com_list_more_up";
                            text.innerText = "收起全部";
                        }else{
                            pre.style.maxHeight = this.getAttribute("height_backup");
                            icon.className = "com_list_more_down";
                            text.innerText = "查看全部";
                        }
                    });
                    //第二次点击查看全部团购是本地脚本操作，仅第一次下发请求
                    evt.on('moreGroupon:tap',function(e){

                    });
                },0);
            }

            dispatcher.append = function(data){
                //console.log(this.initData);
                var body = context.querySelector('.com_list_body');
                var render = artTemplate.compile(this.initData.custom);
                var html = render(data);
                body.innerHTML += html;
            };

            return dispatcher;

        }
    });

    return plg;
});